﻿                
CREATE PROCEDURE [dbo].[SStagin_InsertImportCompanyProfilesFinancial]              
@TemplateName NVARCHAR(200)='',              
@ImportFileName NVARCHAR(200)='',              
@jsonTrend NVARCHAR(MAX) ,
@JsonSegmentInfo NVARCHAR(MAX) ,           
@UserCreatedById UNIQUEIDENTIFIER               
AS              
/*================================================================================                  
Procedure Name: SStagin_InsertImportCompanyProfilesFinancial                 
Change History                  
Date  Developer  Reason                  
__________ ____________ ______________________________________________________                  
07/25/2019 Gopi   Initial Version                  
================================================================================*/               
DECLARE @ImportId UNIQUEIDENTIFIER =NEWID()              
declare @ErrorMsg NVARCHAR(2048),@CreatedOn Datetime              
BEGIN              
 SET @CreatedOn = GETDATE()              
 BEGIN TRY  
 --------------Clear old data if exists-------------------------
   Delete from ImportData where Id in (select Distinct ImportId from StagingCompanyProfilesFinancial SCPF);              
   DELETE from StagingCompanyProfilesFinancial;
   DELETE FROM StagingCompanySegmentInformation;  
 ----------------------------------------------------------------
 
                
 INSERT INTO ImportData              
 (Id               ,               
TemplateName    ,              
ImportFileName    ,              
ImportedOn      ,             
UserImportedById)              
VALUES(@ImportId, @TemplateName, @ImportFileName,@CreatedOn, @UserCreatedById)          
---------------------------------------------------              
INSERT INTO StagingCompanyProfilesFinancial(
Id																												,
ImportId																										,
CompanyName																										,
Currency																										,
Units																											,
FinanicialYear																									,
Revenue																											,
CostsAndExpenses																								,
CostOfProduction																								,
ResourceCost																									,
SalaryCost																										,
CostOfSales																										,
SellingExpenses																									,
MarketingExpenses																								,
AdministrativeExpenses																							,
GeneralExpenses																									,
SellingGeneralAndAdminExpenses																					,
ResearchAndDevelopmentExpenses																					,
Depreciation																									,
Amortization																									,
Restructuring																									,
OtherIncomeOrDeductions																							,
EBIT																											,
InterestIncome																									,
InterestExpense																									,
EBT																												,
Tax																												,
NetIncomeFromContinuingOperations																				,
DiscontinuedOperations																							,
IncomeLossFromDiscontinuedOperations																			,
GainOnDisposalOfDiscontinuedOperations																			,
DiscontinuedOperationsNetOfTax																					,
NetIncomeBeforeAllocationToNoncontrollingInterests																,
NonControllingInterests																							,
NetIncome																										,
BasicEPS_																										,
BasicEPSFromContinuingOperations																				,
BasicEPSFromDiscontinuedOperations																				,
BasicEPS																										,
DilutedEPS_																										,
DilutedEPSFromContinuingOperations																				,
DilutedEPSFromDiscontinuedOperations																			,
DilutedEPS																										,
WeightedAverageSharesOutstandingBasic																			,
WeightedAverageSharesOutstandingDiluted																			,
Assets_																											,
CashAndCashEquivalents																							,
ShortTermInvestments																							,
AccountsReceivables																								,
Inventories																										,
CurrentTaxAssets																								,
OtherCurrentAssets																								,
AssetsHeldForSale																								,
TotalCurrentAssets																								,
LongTermInvestments																								,
PropertyPlantAndEquipment																						,
IntangibleAssets																								,
Goodwill																										,
DeferredTaxAssets																								,
OtherNoncurrentAssets																							,
TotalAssets																										,
LiabilitiesAndEquity_																							,
ShortTermDebt																									,
TradeAccountsPayable																							,
DividendsPayable																								,
IncomeTaxesPayable																								,
AccruedExpenses																									,
OtherCurrentLiabilities																							,
LiabilitiesHeldForSale																							,
TotalCurrentLiabilities																							,
LongTermDebt																									,
PensionBenefitObligations																						,
PostretirementBenefitObligations																				,
DeferredTaxLiabilities																							,
OtherTaxesPayable																								,
OtherNoncurrentLliabilities																						,
TotalLiabilities																								,
CommitmentsAndContingencies_																					,
PreferredStock																									,
CommonStock																										,
Debentures																										,
AdditionalPaidInCapital																							,
TresuryStock																									,
RetainedEarnings																								,
AccumulatedOtherComprehensiveLoss																				,
TotalShareholdersEquity																							,
MinorityInterest																								,
TotalEquity																										,
TotalLiabilitiesAndEquity																						,
OperatingActivities_																							,
AdjustmentsToOperatingActivities_																				,
DepreciationAndAmortization																						,
Impairments																										,
LossOnSaleOfAssets																								,
OtherLossesOrGains																								,
DeferredTaxes																									,
ShareBasedCompensationExpense																					,
BenefitPlanContributions																						,
OtherAdjustmentsNet																								,
OtherChangesInAssetsAndLiabilitiesNetOfAcquisitionsAndDistitures_												,
AccountsReceivable																								,
OtherAssets																										,
AccountsPayable																									,
OtherLiabilities																								,
OtherTaxAccountsNet																								,
NetCashProvidedByOrUsedInOperatingActivities																	,
InvestingActivities_																							,
PurchasesOfPropertyPlantAndEquipment																			,
PurchasesOfShortTermInvestments																					,
SaleOfShortTermInvestments																						,
RedemptionsOfShortTermInvestments																				,
PurchasesOfLongTermInvestments																					,
SaleOfLongTermInvestments																						,
BusinessAcquisitions																							,
AcquisitionsOfIntangibleAssets																					,
OtherInvestingActivitiesNet																						,
NetCashProvidedByOrUsedInInvestingActivities																	,
FinancingActivities_																							,
ProceedsFromShortTermDebt																						,
PrincipalPaymentsOnShortTermDebt																				,
NetPaymentsonOrProceedsFromShortTermBorrowingsWithOrigilMaturitiesOfThreeMonthsOrLess 							,
IssuanceOfLongTermDebt																							,
PrincipalPaymentsOnLongTermDebt																					,
PurchasesOfCommonStock																							,
CashDividendsPaid																								,
ProceedsFromExerciseOfStockOptions																				,
OtherFinancingActivitiesNet																						,
NetCashProvidedByOrUsedInFinancingActivities																	,
ForeignExchangeImpact																							,
DecreaseInCashAndCashEquivalents																				,
OpeningBalanceOfCashAndCashEquivalents																			,
ClosingBalanceOfCashAndCashEquivalents																			,
CashPaidReceivedDuringThePeriodFor_																				,
IncomeTaxes																										,
InterestRateHedges																								,
GrossProfit,
TotalOperatingExpenses,
EBITDA,
DeferredRevenuesShortTerm,
DeferredRevenuesLongTerm,
CommonStockRepurchased,
CapitalExpenditure,
UserCreatedById	
--CompanyId,
--CurrencyId,
--ValueConversionId,
--ErrorNotes    
)              
SELECT              
       NEWID()               ,                
@ImportId       ,         

CompanyName																										,
Currency																										,
Units																											,
FinanicialYear																									,
Revenue																											,
CostsAndExpenses																								,
CostOfProduction																								,
ResourceCost																									,
SalaryCost																										,
CostOfSales																										,
SellingExpenses																									,
MarketingExpenses																								,
AdministrativeExpenses																							,
GeneralExpenses																									,
SellingGeneralAndAdminExpenses																					,
ResearchAndDevelopmentExpenses																					,
Depreciation																									,
Amortization																									,
Restructuring																									,
OtherIncomeOrDeductions																							,
EBIT																											,
InterestIncome																									,
InterestExpense																									,
EBT																												,
Tax																												,
NetIncomeFromContinuingOperations																				,
DiscontinuedOperations																							,
IncomeLossFromDiscontinuedOperations																			,
GainOnDisposalOfDiscontinuedOperations																			,
DiscontinuedOperationsNetOfTax																					,
NetIncomeBeforeAllocationToNoncontrollingInterests																,
NonControllingInterests																							,
NetIncome																										,
BasicEPS_																										,
BasicEPSFromContinuingOperations																				,
BasicEPSFromDiscontinuedOperations																				,
BasicEPS																										,
DilutedEPS_																										,
DilutedEPSFromContinuingOperations																				,
DilutedEPSFromDiscontinuedOperations																			,
DilutedEPS																										,
WeightedAverageSharesOutstandingBasic																			,
WeightedAverageSharesOutstandingDiluted																			,
Assets_																											,
CashAndCashEquivalents																							,
ShortTermInvestments																							,
AccountsReceivables																								,
Inventories																										,
CurrentTaxAssets																								,
OtherCurrentAssets																								,
AssetsHeldForSale																								,
TotalCurrentAssets																								,
LongTermInvestments																								,
PropertyPlantAndEquipment																						,
IntangibleAssets																								,
Goodwill																										,
DeferredTaxAssets																								,
OtherNoncurrentAssets																							,
TotalAssets																										,
LiabilitiesAndEquity_																							,
ShortTermDebt																									,
TradeAccountsPayable																							,
DividendsPayable																								,
IncomeTaxesPayable																								,
AccruedExpenses																									,
OtherCurrentLiabilities																							,
LiabilitiesHeldForSale																							,
TotalCurrentLiabilities																							,
LongTermDebt																									,
PensionBenefitObligations																						,
PostretirementBenefitObligations																				,
DeferredTaxLiabilities																							,
OtherTaxesPayable																								,
OtherNoncurrentLliabilities																						,
TotalLiabilities																								,
CommitmentsAndContingencies_																					,
PreferredStock																									,
CommonStock																										,
Debentures																										,
AdditionalPaidInCapital																							,
TresuryStock																									,
RetainedEarnings																								,
AccumulatedOtherComprehensiveLoss																				,
TotalShareholdersEquity																							,
MinorityInterest																								,
TotalEquity																										,
TotalLiabilitiesAndEquity																						,
OperatingActivities_																							,
AdjustmentsToOperatingActivities_																				,
DepreciationAndAmortization																						,
Impairments																										,
LossOnSaleOfAssets																								,
OtherLossesOrGains																								,
DeferredTaxes																									,
ShareBasedCompensationExpense																					,
BenefitPlanContributions																						,
OtherAdjustmentsNet																								,
OtherChangesInAssetsAndLiabilitiesNetOfAcquisitionsAndDistitures_												,
AccountsReceivable																								,
OtherAssets																										,
AccountsPayable																									,
OtherLiabilities																								,
OtherTaxAccountsNet																								,
NetCashProvidedByOrUsedInOperatingActivities																	,
InvestingActivities_																							,
PurchasesOfPropertyPlantAndEquipment																			,
PurchasesOfShortTermInvestments																					,
SaleOfShortTermInvestments																						,
RedemptionsOfShortTermInvestments																				,
PurchasesOfLongTermInvestments																					,
SaleOfLongTermInvestments																						,
BusinessAcquisitions																							,
AcquisitionsOfIntangibleAssets																					,
OtherInvestingActivitiesNet																						,
NetCashProvidedByOrUsedInInvestingActivities																	,
FinancingActivities_																							,
ProceedsFromShortTermDebt																						,
PrincipalPaymentsOnShortTermDebt																				,
NetPaymentsonOrProceedsFromShortTermBorrowingsWithOrigilMaturitiesOfThreeMonthsOrLess 							,
IssuanceOfLongTermDebt																							,
PrincipalPaymentsOnLongTermDebt																					,
PurchasesOfCommonStock																							,
CashDividendsPaid																								,
ProceedsFromExerciseOfStockOptions																				,
OtherFinancingActivitiesNet																						,
NetCashProvidedByOrUsedInFinancingActivities																	,
ForeignExchangeImpact																							,
DecreaseInCashAndCashEquivalents																				,
OpeningBalanceOfCashAndCashEquivalents																			,
ClosingBalanceOfCashAndCashEquivalents																			,
CashPaidReceivedDuringThePeriodFor_																				,
IncomeTaxes																										,
InterestRateHedges																								,
GrossProfit,
TotalOperatingExpenses,
EBITDA,
DeferredRevenuesShortTerm,
DeferredRevenuesLongTerm,
CommonStockRepurchased,
CapitalExpenditure,
@UserCreatedById    
    FROM OPENJSON(@jsonTrend)              
    WITH (              

[CompanyName] [nvarchar](255),
[Currency] [nvarchar](255),
[Units] [nvarchar](255),
[FinanicialYear] [nvarchar](255),
[Revenue] [nvarchar](255),
[CostsAndExpenses] [nvarchar](255),
[CostOfProduction] [nvarchar](255),
[ResourceCost] [nvarchar](255),
[SalaryCost] [nvarchar](255),
[CostOfSales] [nvarchar](255),
[SellingExpenses] [nvarchar](255),
[MarketingExpenses] [nvarchar](255),
[AdministrativeExpenses] [nvarchar](255),
[GeneralExpenses] [nvarchar](255),
[SellingGeneralAndAdminExpenses] [nvarchar](255),
[ResearchAndDevelopmentExpenses] [nvarchar](255),
[Depreciation] [nvarchar](255),
[Amortization] [nvarchar](255),
[Restructuring] [nvarchar](255),
[OtherIncomeOrDeductions] [nvarchar](255),
[EBIT] [nvarchar](255),
[InterestIncome] [nvarchar](255),
[InterestExpense] [nvarchar](255),
[EBT] [nvarchar](255),
[Tax] [nvarchar](255),
[NetIncomeFromContinuingOperations] [nvarchar](255),
[DiscontinuedOperations] [nvarchar](255),
[IncomeLossFromDiscontinuedOperations] [nvarchar](255),
[GainOnDisposalOfDiscontinuedOperations] [nvarchar](255),
[DiscontinuedOperationsNetOfTax] [nvarchar](255),
[NetIncomeBeforeAllocationToNoncontrollingInterests] [nvarchar](255),
[NonControllingInterests] [nvarchar](255),
[NetIncome] [nvarchar](255),
[BasicEPS_] [nvarchar](255),
[BasicEPSFromContinuingOperations] [nvarchar](255),
[BasicEPSFromDiscontinuedOperations] [nvarchar](255),
[BasicEPS] [nvarchar](255),
[DilutedEPS_] [nvarchar](255),
[DilutedEPSFromContinuingOperations] [nvarchar](255),
[DilutedEPSFromDiscontinuedOperations] [nvarchar](255),
[DilutedEPS] [nvarchar](255),
[WeightedAverageSharesOutstandingBasic] [nvarchar](255),
[WeightedAverageSharesOutstandingDiluted] [nvarchar](255),
[Assets_] [nvarchar](255),
[CashAndCashEquivalents] [nvarchar](255),
[ShortTermInvestments] [nvarchar](255),
[AccountsReceivables] [nvarchar](255),
[Inventories] [nvarchar](255),
[CurrentTaxAssets] [nvarchar](255),
[OtherCurrentAssets] [nvarchar](255),
[AssetsHeldForSale] [nvarchar](255),
[TotalCurrentAssets] [nvarchar](255),
[LongTermInvestments] [nvarchar](255),
[PropertyPlantAndEquipment] [nvarchar](255),
[IntangibleAssets] [nvarchar](255),
[Goodwill] [nvarchar](255),
[DeferredTaxAssets] [nvarchar](255),
[OtherNoncurrentAssets] [nvarchar](255),
[TotalAssets] [nvarchar](255),
[LiabilitiesAndEquity_] [nvarchar](255),
[ShortTermDebt] [nvarchar](255),
[TradeAccountsPayable] [nvarchar](255),
[DividendsPayable] [nvarchar](255),
[IncomeTaxesPayable] [nvarchar](255),
[AccruedExpenses] [nvarchar](255),
[OtherCurrentLiabilities] [nvarchar](255),
[LiabilitiesHeldForSale] [nvarchar](255),
[TotalCurrentLiabilities] [nvarchar](255),
[LongTermDebt] [nvarchar](255),
[PensionBenefitObligations] [nvarchar](255),
[PostretirementBenefitObligations] [nvarchar](255),
[DeferredTaxLiabilities] [nvarchar](255),
[OtherTaxesPayable] [nvarchar](255),
[OtherNoncurrentLliabilities] [nvarchar](255),
[TotalLiabilities] [nvarchar](255),
[CommitmentsAndContingencies_] [nvarchar](255),
[PreferredStock] [nvarchar](255),
[CommonStock] [nvarchar](255),
[Debentures] [nvarchar](255),
[AdditionalPaidInCapital] [nvarchar](255),
[TresuryStock] [nvarchar](255),
[RetainedEarnings] [nvarchar](255),
[AccumulatedOtherComprehensiveLoss] [nvarchar](255),
[TotalShareholdersEquity] [nvarchar](255),
[MinorityInterest] [nvarchar](255),
[TotalEquity] [nvarchar](255),
[TotalLiabilitiesAndEquity] [nvarchar](255),
[OperatingActivities_] [nvarchar](255),
[AdjustmentsToOperatingActivities_] [nvarchar](255),
[DepreciationAndAmortization] [nvarchar](255),
[Impairments] [nvarchar](255),
[LossOnSaleOfAssets] [nvarchar](255),
[OtherLossesOrGains] [nvarchar](255),
[DeferredTaxes] [nvarchar](255),
[ShareBasedCompensationExpense] [nvarchar](255),
[BenefitPlanContributions] [nvarchar](255),
[OtherAdjustmentsNet] [nvarchar](255),
[OtherChangesInAssetsAndLiabilitiesNetOfAcquisitionsAndDistitures_] [nvarchar](255),
[AccountsReceivable] [nvarchar](255),
[OtherAssets] [nvarchar](255),
[AccountsPayable] [nvarchar](255),
[OtherLiabilities] [nvarchar](255),
[OtherTaxAccountsNet] [nvarchar](255),
[NetCashProvidedByOrUsedInOperatingActivities] [nvarchar](255),
[InvestingActivities_] [nvarchar](255),
[PurchasesOfPropertyPlantAndEquipment] [nvarchar](255),
[PurchasesOfShortTermInvestments] [nvarchar](255),
[SaleOfShortTermInvestments] [nvarchar](255),
[RedemptionsOfShortTermInvestments] [nvarchar](255),
[PurchasesOfLongTermInvestments] [nvarchar](255),
[SaleOfLongTermInvestments] [nvarchar](255),
[BusinessAcquisitions] [nvarchar](255),
[AcquisitionsOfIntangibleAssets] [nvarchar](255),
[OtherInvestingActivitiesNet] [nvarchar](255),
[NetCashProvidedByOrUsedInInvestingActivities] [nvarchar](255),
[FinancingActivities_] [nvarchar](255),
[ProceedsFromShortTermDebt] [nvarchar](255),
[PrincipalPaymentsOnShortTermDebt] [nvarchar](255),
[NetPaymentsonOrProceedsFromShortTermBorrowingsWithOrigilMaturitiesOfThreeMonthsOrLess] [nvarchar](255),
[IssuanceOfLongTermDebt] [nvarchar](255),
[PrincipalPaymentsOnLongTermDebt] [nvarchar](255),
[PurchasesOfCommonStock] [nvarchar](255),
[CashDividendsPaid] [nvarchar](255),
[ProceedsFromExerciseOfStockOptions] [nvarchar](255),
[OtherFinancingActivitiesNet] [nvarchar](255),
[NetCashProvidedByOrUsedInFinancingActivities] [nvarchar](255),
[ForeignExchangeImpact] [nvarchar](255),
[DecreaseInCashAndCashEquivalents] [nvarchar](255),
[OpeningBalanceOfCashAndCashEquivalents] [nvarchar](255),
[ClosingBalanceOfCashAndCashEquivalents] [nvarchar](255),
[CashPaidReceivedDuringThePeriodFor_] [nvarchar](255),
[IncomeTaxes] [nvarchar](255),
[InterestRateHedges] [nvarchar](255),
[GrossProfit] [nvarchar](255),
[TotalOperatingExpenses] [nvarchar](255),
[EBITDA] [nvarchar](255),
[DeferredRevenuesShortTerm] [nvarchar](255),
[DeferredRevenuesLongTerm] [nvarchar](255),
[CommonStockRepurchased] [nvarchar](255),
[CapitalExpenditure] [nvarchar](255),
 [UserCreatedById] [nvarchar](255)     
    ) AS jsonTrends  
	
INSERT INTO StagingCompanySegmentInformation(
Id,
ImportId,
CompanyName,
Currency,
Units,
FinanicialYear,
[Type],
[Name] ,
[Value] ,
UserCreatedById)
SELECT              
NEWID(),                
@ImportId,         
CompanyName,
Currency,
Units,
FinanicialYear,
[Type],
[Name] ,
[Value] ,
@UserCreatedById 
FROM OPENJSON(@JsonSegmentInfo)              
WITH (
[CompanyName] [nvarchar](255),
[Currency] [nvarchar](255),
[Units] [nvarchar](255),
[FinanicialYear] [nvarchar](255),
[Type] [nvarchar](255),
[Name] [nvarchar](255),
[Value] [nvarchar](255),
[UserCreatedById] [nvarchar](255)     
) AS JsonSegmentInfo	
	            
               
              
 SELECT StoredProcedureName ='SStagin_InsertImportCompanyProfilesFinancial',Message =@ErrorMsg,Success = 1;                 
END TRY                  
BEGIN CATCH                  
    -- Execute the error retrieval routine.                  
 DECLARE @ErrorNumber int;                  
 DECLARE @ErrorSeverity int;                  
 DECLARE @ErrorProcedure varchar(100);                  
 DECLARE @ErrorLine int;                  
 DECLARE @ErrorMessage varchar(500);                  
                  
  SELECT @ErrorNumber = ERROR_NUMBER(),                  
        @ErrorSeverity = ERROR_SEVERITY(),                  
        @ErrorProcedure = ERROR_PROCEDURE(),                  
        @ErrorLine = ERROR_LINE(),                  
        @ErrorMessage = ERROR_MESSAGE()                  
                  
 insert into dbo.Errorlog(ErrorNumber,                  
       ErrorSeverity,                  
       ErrorProcedure,                  
       ErrorLine,                  
       ErrorMessage,                  
       ErrorDate)                  
        values(@ErrorNumber,@ErrorSeverity,@ErrorProcedure,@ErrorLine,@ErrorMessage,@CreatedOn);                  
                
 set @ErrorMsg = 'Error while importing CompanyProfilesFinancial, please contact Admin for more details.';                  
--THROW 50000,@ErrorMsg,1;                    
--return(1)                
SELECT Number = @ErrorNumber, Severity =@ErrorSeverity,StoredProcedureName =@ErrorProcedure,LineNumber= @ErrorLine                
    ,Message =@ErrorMsg,Success = 0;                   
                   
END CATCH                   
              
              
END